unit epmsg;
interface

uses
    SysUtils, dvcrt, dvWin, dvLenum, dvForm;

procedure mensagem (nomeArq: string; nlf: integer);
function pegaTextoMensagem (nomeArq: string): string;
procedure soletra(s: string; nlf: integer);
procedure limpaBaixo (y: integer);
procedure menuAdiciona (cod: string);
function pergunta (msg: string; npula: integer; cor: integer): char;
procedure msgMuda (nomeArq: string; nlf: integer);
function trocaBarra(dir: String): String;

implementation

function pegaTextoMensagem (nomeArq: string): string;
var s: string;
begin
   if      nomeArq = 'EPUBVOX'  then s := 'EPUBVOX - Verso '
   else if nomeArq = 'EPFIM'    then s := 'Fim do EPUBVOX'
   else if nomeArq = 'EPQOPCAO' then s := 'Selecione a opo com as setas:'
   else if nomeArq = 'EPQNEPUB' then s := 'Informe o nome do livro:'
   else if nomeArq = 'EPNLIVRO' then s := 'Livro: '   
   else if nomeArq = 'EPNENCON' then s := 'Pasta vazia ou nenhum arquivo selecionado.'
   else if nomeArq = 'EPCONFIR' then s := 'Confirma o fim do Epubvox? '
// else if nomeArq = 'EPDFAULT' then s := 'Manter a configurao padro?(S/N) '
   else if nomeArq = 'EPNAO' then s := 'No'
   else if nomeArq = 'EPSIM' then s := 'Sim'
   else if nomeArq = 'EPNLVTXT' then s := 'Informe o nome do arquivo de texto a salvar: '
   else if nomeArq = 'EPPROCES' then s := 'Extraindo arquivo EPUB  '
   else if nomeArq = 'EPERRODC' then s := 'Descompactador no pde ser executado.'
   else if nomeArq = 'EPFPROCE' then s := 'Fim da extrao'

   else if nomeArq = 'EPERRORN' then s := 'Nome de arquivo invlido.'
   else if nomeArq = 'EPERRORE' then s := 'Tipo de arquivo no suportado.'
   else if nomeArq = 'EPERRORC' then s := 'Erro ao copiar dados do arquivo.'
   else if nomeArq = 'EPERRORZ' then s := 'Erro na extrao do arquivo'
   else if nomeArq = 'EPSAIDAD' then s := 'Ser salvo no diretrio atual.'
   else if nomeArq = 'EPIMAGTB' then s := 'Extrai imagens tambm? '
   else if nomeArq = 'EPEXTIMG' then s := 'Extraindo as imagens.'

   else if nomeArq = 'EPERRIMG' then s := 'Diretrio de imagens no pde ser criado'
   else if nomeArq = 'EPLOCALS' then s := 'Livro salvo em: '
   else if nomeArq = 'EPEDIVOX' then s := 'Voltando para o Edivox'
//   else if nomeArq = 'xxxxxx' then s := 'xxxxxx'


   else
        s := '--> Mensagem invlida: ' + nomeArq;

   pegaTextoMensagem := s;
end;

{--------------------------------------------------------}
{              d uma mensagem sem falar
{--------------------------------------------------------}

procedure msgMuda (nomeArq: string; nlf: integer);
var i: integer;
    s: string;

begin
    s := pegaTextoMensagem (nomeArq);

    if nlf >= 0 then write (s);
    for i := 1 to nlf do
         writeln;
end;

{--------------------------------------------------------}
{              d uma mensagem falando
{--------------------------------------------------------}

procedure mensagem (nomeArq: string; nlf: integer);
var i: integer;
    s: string;

begin
    s := pegaTextoMensagem (nomeArq);

    if nlf >= 0 then write (s);
    for i := 1 to nlf do
         writeln;

    if (nomeArq <> '') and (existeArqSom (nomearq)) then
        sintSom (nomearq)
    else
        sintetiza (s);

    while sintFalando do keypressed;
end;

{--------------------------------------------------------}
{               Soletra uma string
{--------------------------------------------------------}

procedure soletra(s: string; nlf: integer);
var i: integer;
begin
     write (s);
     for i := 1 to nlf do
         writeln;
     for i := 1 to length (s) do
         sintSoletra (s[i]);
end;

{--------------------------------------------------------}
{             Limpa as linhas que estao abaixo
{--------------------------------------------------------}

procedure limpaBaixo (y: integer);
var i: integer;
begin
    for i := y to currentWindow.Bottom - 1 do
        begin
            gotoxy (1, i);
            clreol;
        end;
    gotoxy (1, y);
end;

{--------------------------------------------------------}
{       adiciona ao menu (rotina de convenincia)
{--------------------------------------------------------}

procedure menuAdiciona (cod: string);
begin
    popupMenuAdiciona (cod, pegaTextoMensagem(cod));
end;

{--------------------------------------------------------}
{                faz uma pergunta
{--------------------------------------------------------}

function pergunta (msg: string; npula: integer; cor: integer): char;
var c, c2: char;
begin
    textBackground (cor);
    mensagem (msg, 0);
    textBackground (BLACK);
    sintLeTecla (c, c2);
    pergunta := upcase(c);

    if c <> #$0 then
        begin
            c := upcase (c);
            gotoxy(wherex-1,wherey);
            ClrEol;
        end;
    gotoxy(wherex,wherey);
end;

{--------------------------------------------------------}
{               Inverte barras
{--------------------------------------------------------}

function trocaBarra(dir: String): String;
begin
    result := StringReplace(dir, '/', '\', [rfReplaceAll, rfIgnoreCase]);
end;

end.


