unit gvbusca;

interface
uses windows, sysutils, shellApi, classes,
     dvcrt, dvWin, dvInet, dvArq, dvForm, dvExec, dvSsl, winsock,
     gvHttp, gvHtml, gvVars, gvMsg;

procedure buscaNoGoogle (busca: string; nivelDeBusca: integer);

implementation

{--------------------------------------------------------}
{            faz uma pesquisa pelo site                  }
{--------------------------------------------------------}

function trazDoGoogle (busca: string; pagInicio: integer): string;
var
    httpMsg, cook, infosite, s: string;
    i, status: integer;
begin
    if pagInicio = 0 then
         infosite := '/search' +
                     '?ie=ISO%2D8859%2D1'+
                     '&hl=pt-BR'+
                     '&source=hp&biw=&bih=' +
                     '&q=' + UrlEncode2(busca) +
                     '&btnG=Pesquisa+Google' +
                     '&iflsig=' + iflsig +
                     '&gbv=1'
    else
        infosite := busca;

    httpMsg :=
            'GET ' + infosite + ' HTTP/1.0' + ^m^j +
            'Host: ' + siteGoogle + ^m^j +
            'Accept-Language: pt-br' + ^m^j +
            'UA-CPU: x86' + ^m^j +
            'User-Agent: GoogleVox 2.0' + ^m^j;

    for i := 0 to cookies.count-1 do
        begin
            cook := copy (cookies[i], 1, pos(';', cookies[i])-1);
            if pos (copy (cook, 1, pos('=', cook)), infosite) = 1 then
                httpMsg := httpMsg + 'Cookie=' + cook + ^m^j;
        end;

    httpMsg := httpMsg + ^m^j;

    if debug then
        begin
            textColor (YELLOW);
            writeln ('Site:   ', siteGoogle);
            writeln ('URL:    ', infosite);
            for i := 0 to cookies.count-1 do
                 writeln ('Cookie: ', cookies[i]);
            textColor (WHITE);
            write ('Aperte enter');
            readln;
            writeln;
        end;

    s := httpTransport (siteGoogle, 80, httpMsg, status, newLocation, cookies);

    if status <> 200 then
        begin
            mensagem ('GVPRBGOO', 2);  {'Comunicao com a Google no foi estabelecida'}
            s := '';
            exit;
        end;

    result := s;
end;

{-----------------------------------------------------------}
{          rotinas de criao e exibio da janela
{-----------------------------------------------------------}

procedure adicionaAosUltimos (chaveBusca: string);
var i, j: integer;
begin
    for i := 1 to 10 do
        begin
            if chaveBusca = ultimasBuscas[i] then
                begin
                    for j := i to 10-1 do
                        ultimasBuscas[j] := ultimasBuscas[j+1];
                    ultimasBuscas[10] := '';
                end;
        end;

    if (chaveBusca <> '') and (chaveBusca <> ultimasBuscas[1]) then
       begin
           for i := 10 downto 2 do
               ultimasBuscas[i] := ultimasBuscas[i-1];
           ultimasBuscas[1] := chaveBusca;
           for i := 1 to 10 do
               sintGravaAmbiente ('GOOGLEVOX', intToStr(i), ultimasBuscas[i]);
       end;
end;

{--------------------------------------------------------}
{                      faz uma busca                     }
{--------------------------------------------------------}

procedure buscaNoGoogle (busca: string; nivelDeBusca: integer);
var
    nn : integer;
    s: string;
    i: integer;
    p: integer;
    numRegLidos: integer;
    sl: TStringList;
    titulo: string;
    url: string;
    descricao: string;
    transf: string;
    proxCmdBusca: string;

begin
    numRegLidos := 0;

    for nn := 0 to nivelDeBusca-1 do
        begin
            if nn = 0 then
                s := trazDoGoogle (busca, nn)
            else
                s := trazDoGoogle (proxCmdBusca, nn);

            if s <> '' then
                begin
                    sl := TStringList.create;
                    sl.assign (HTMLparaStringList(s));
                    for i := sl.count-1 downto 0 do
                        if trim(sl[i]) = '' then
                             sl.Delete(i);

                    if debug then
                        sl.SaveToFile('c:\temp\' + UrlEncode2(busca) + '_' + intToStr(nn) + '.htm');

                    i := 0;
                    while i < sl.count do
                        begin
                            if (pos ('<a href="/url?', sl[i]) = 1) then
                                begin
                                    url := copy (sl[i], 10, 9999);
                                    delete (url, 1, 7);
                                    p := pos ('&amp;', LowerCase(url));
                                    delete (url, p, length(url)-p+1);

                                    if pos ('https://accounts.google.com/ServiceLogin', url) = 1 then
                                        break;

                                    repeat
                                        i := i + 1;
                                    until (i >= sl.count) or (sl[i][1] <> '<');

                                    if i >= sl.count then break;

                                    titulo := sl[i];

                                    descricao := '';
                                    transf := '';

                                    for i := i to sl.count-1 do
                                        begin
                                             if pos ('<a href="/url?', sl[i]) = 1 then break;
                                             if (sl[i] <> '') and (sl[i][1] <> '<') then
                                                  if (transf = '') and (upperCase(copy (sl[i], 1, 4)) = 'HTTP') then
                                                        transf := sl[i] + ^m^j
                                                    else
                                                        descricao := descricao + sl[i] + ^m^j;
                                        end;
                                    i := i - 1;

                                    if transf <> '' then
                                        descricao := descricao + transf;

                                        resultado.add (traduzLetrasHTML(titulo));
                                        resultado.add (traduzLetrasHTML(descricao));
                                        url := hexDecode(url);
                                        resultado.add (url);
                                        numRegLidos := numRegLidos + 1;
                                    end;

                            i := i + 1;
                        end;

                    proxCmdBusca := '';
                    for i := sl.count-1 downto 0 do
                        if (pos ('"/search?', sl[i]) <> 0) and
                           (pos ('aria-label=', sl[i]) <> 0) then
                                begin
                                    proxCmdBusca := sl[i];
                                    delete (proxCmdBusca, 1, pos ('href=', proxCmdBusca)+5);
                                    delete (proxCmdBusca, pos('aria-label', proxCmdBusca)-2, 999);
                                    break;
                                end;
                    sl.free;

                    delay (2000)   // evita que o google bloqueie o googlevox
                end;

            sintbip;
        end;

    if numRegLidos <> 0 then
         adicionaAosUltimos (busca);

    writeln;
    sintWriteln (intToStr(numRegLidos) + ' registros encontrados. Aperte enter');
    readkey;
    limpabuftec;
end;

end.

