{--------------------------------------------------------}
{
{    Programa de converso do cdigos para o Braivox
{
{    Autor: Jose' Antonio Borges
{
{    Em 18/3/99
{
{--------------------------------------------------------}

program transcod;
uses dvCrt, dvWin, windows, sysUtils;

var nomeArq, nomeSai, nomeArqCod: string;
    arq, arqsai, arqcod: text;
    tamTab: integer;
    txorig, txnovo: array [1..10000] of string;

{--------------------------------------------------------}
{                finaliza programa
{--------------------------------------------------------}

procedure finaliza;
begin
    while sintFalando do;
    sintFim;
    doneWinCrt;
end;

{--------------------------------------------------------}
{             inicializa e abre arquivos
{--------------------------------------------------------}

procedure inicializa;
var diret: string;
begin
    clrscr;
    diret := sintAmbiente ('TRANSCOD', 'DIRTRANSCOD');
    if diret = '' then
        diret := 'c:\winvox\som\transcod';
    sintInic (0, diret);

    writeln ('Conversor de cdigos para o Braivox - v1.0');
    sintSom ('CVINIC');
    writeln;

    writeln ('Qual o arquivo a converter ? ');
    sintSom ('CVNOMARQ');

    sintReadln (nomeArq);
    if nomeArq = '' then doneWinCrt;

    assign (arq, nomeArq);
    {$I-}  reset (arq);  {$I+}
    if ioresult <> 0 then
        begin
            writeln ('Arquivo no existe, programa terminado');
            sintSom ('CVARQNAO');
            finaliza;
        end;
    close (arq);

    writeln ('Qual o arquivo de sada ? ');
    sintSom ('CVNOMSAI');

    sintReadln (nomeSai);
    if nomeSai = '' then doneWinCrt;
    assign (arqSai, nomeSai);
end;

{--------------------------------------------------------}
{                 carrega a codificacao
{--------------------------------------------------------}

procedure carregaCodigo;
var
    linha, p: integer;
    original, novoTexto, s: string;
begin
    writeln ('Qual o arquivo de codificao ? Assumo \winvox\codmat.amb');
    sintSom ('CVARQCOD');
    sintReadln (nomeArqCod);

    if nomeArqCod = '' then
         if sintAmbiente ('TRADUTOR', 'MINIVOX') = 'SIM' then
             nomeArqCod := sintAmbiente ('DOSVOX', 'PGMDOSVOX') + '\codmat.amb'
         else
             nomeArqCod := 'c:\winvox\codmat.amb';

    assign (arqCod, nomeArqCod);
    {$I-}  reset (arqCod);  {$I+}
    if ioresult <> 0 then
        begin
            writeln ('Arquivo de codificao no existe, programa terminado');
            sintSom ('CVCODNAO');
            finaliza;
        end;

    linha := 0;
    tamTab := 0;
    while not eof (arqCod) do
        begin
            readln (arqCod, s);
            linha := linha + 1;
            if (s = '') or (s[1] = ';') then
                { nada faz }
            else
            if s[1] <> '`' then
                begin
                    write ('Codigo invlido na linha ');
                    sintSom ('CVCODINV');
                    sintWriteInt (linha);
                    writeln;
                end
            else
                begin
                    original := '';
                    novoTexto := '';
                    tamTab := tamTab + 1;
                    p := 1;
                    while (p <= length (s)) and (s[p] <> ' ') do
                        begin
                            original := original + s[p];
                            p := p + 1;
                        end;
                    while (p <= length (s)) and (s[p] = ' ') do
                        p := p + 1;
                    while (p <= length (s)) and (s[p] <> ' ') do
                        begin
                            novoTexto := novoTexto + s[p];
                            p := p + 1;
                        end;

                    txorig [tamTab] := original;
                    txnovo [tamTab] := novoTexto;
                end;
        end;

    close (arqCod);
end;

{--------------------------------------------------------}
{                 busca texto novo
{--------------------------------------------------------}

procedure buscaTroca (const texto: string; posInicial: integer;
                      var avancar: integer; var troca: string);
var i, tam: integer;
begin
    troca := '';
    for i := 1 to tamTab do
        begin
            tam := length (txOrig [i]);
            if copy (texto, posInicial, tam) = txOrig [i] then
                begin
                    troca := txNovo [i];
                    avancar := tam;
                    exit;
                end;
        end;

    avancar := 1;
    troca := texto [posInicial];
end;

{--------------------------------------------------------}
{        transcreve o texto fazendo alteracoes
{--------------------------------------------------------}

procedure transcreve;
var s, saida, troca: string;
    p, avancar: integer;
label errodisco, ok;
begin
    reset (arq);
    rewrite (arqSai);

    while not eof (arq) do
        begin
            {$I-} readln (arq, s);  {$I+}
            if ioresult <> 0 then goto errodisco;

            p := 1;
            saida := '';
            while p <= length (s) do
                begin
                    if s[p] <> '`' then
                        begin
                            saida := saida + s[p];
                            p := p + 1;
                        end
                    else
                        begin
                            buscaTroca (s, p, avancar, troca);
                            p := p + avancar;
                            saida := saida + troca;
                        end;
                end;

            {$I-} writeln (arqSai, saida);   {$I+}
            if ioresult <> 0 then goto errodisco;
        end;

    goto ok;

erroDisco:
    writeln ('Problemas no disco');
    sintSom ('CVERRDSK');

ok:
    {$I-}  close (arq);  {$I+}
    if ioresult <> 0 then;
    {$I-}  close (arqSai); {$I+}
    if ioresult <> 0 then;
end;

{--------------------------------------------------------}
{             programa principal
{--------------------------------------------------------}

begin
    inicializa;
    carregaCodigo;
    transcreve;

    writeln ('Converso terminada');
    sintSom ('CVFIM');
    finaliza;
end.
