{--------------------------------------------------------}
{                                                        }
{    Programa de acesso a redes sociais                  }
{                                                        }
{    Programa principal                                  }
{                                                        }
{    Autor: Jos Antonio Borges                          }
{                                                        }
{    Em dezembro/2011                                    }
{                                                        }
{--------------------------------------------------------}

program twitvox;

uses
  dvcrt,
  dvwin,
  dvform,
  sysUtils,
  winsock,
  dvinet,
  twmsg,
  twvars,
  twpost,
  twutil,
  twfolhe,
  twinfusu,
  twapi,
  twlogin,
  twamigos,
  twexibe,
  twdraw,
  twconfig,
  twimg,
  twgzip;

{--------------------------------------------------------}

procedure finaliza;
begin
    fechaWinSock;

    gotoxy (1, 25);
    mensagem ('TWFIM', 0);  {'Fim do Twitter Vox'}
    delay (2000);
    while sintFalando do;
    doneWinCrt;
end;

{--------------------------------------------------------}

procedure inicializa;
var ambiente: string;
begin
    ambiente := sintAmbiente ('TWITVOX', 'DIRTWITVOX');
    if ambiente = '' then
        ambiente := 'c:\winvox\som\twitvox';
    sintInic (0, ambiente);

    twitvoxConfigs := sintAmbiente ('TWITVOX','ARQCONFIGS');
    if twitvoxConfigs = '' then
        twitvoxConfigs := 'TWITVOX.INI';

    clrscr;

    setWindowTitle ('Twitvox - v.' + versao);
    exibeFigura (ambiente+'\dosvox_twitvox.jpg', 400, 10);

    textBackground (BLUE);
    mensagem ('TWINIC',0);  {'Twitter Vox - verso '}
    sintWriteln (versao);
    writeln;
    textBackground (BLACK);

    if not abreWinSock then
        begin
            mensagem ('TWERRCOM', 1);  {'No consegui ativar o sistema de comunicao do micro'}
            finaliza;
        end;

    nomeArqSalva := 'twits.txt';
    tamRotulosForm := 24;
end;

{--------------------------------------------------------}

procedure ajudaPrincipal;
begin
    limpaBaixo;
    writeln;
    mensagem ('TWOPSAO', 1);   {'As opes so:'}
    mensagem ('TWOP_T', 1);    {'T - tuitar uma mensagem'}
    mensagem ('TWOP_L', 1);    {'L - linha do tempo'}
    mensagem ('TWOP_F', 1);    {'F - folhear'}
    mensagem ('TWOP_B', 1);    {'B - buscar contedos'}
    mensagem ('TWOP_D', 1);    {'D - enviar mensagem direta'}
    mensagem ('TWOP_M', 1);    {'M - mensagens diretas para mim'}
    mensagem ('TWOP_I', 1);    {'I - obter informaes sobre algum'}
    mensagem ('TWOP_A', 1);    {'A - amigos'}
    mensagem ('TWOP_S', 1);    {'S - seguidores'}
    mensagem ('TWOP_C', 1);    {'C - configuraes'}
    mensagem ('TWOP_ESC', 2);  {'ESC - terminar'}
end;

{--------------------------------------------------------}

function selSetasOpcao: char;
var n: integer;
const
    opmenu: string = 'TLFBMDIASC' + #$1b;
begin
    popupMenuCria(wherex, wherey, 50, length(opmenu), RED);
    MenuAdiciona ('TWOP_T');     {'T - tuitar uma mensagem'}
    MenuAdiciona ('TWOP_L');     {'L - linha do tempo'}
    MenuAdiciona ('TWOP_F');     {'F - folhear mensagens'}
    MenuAdiciona ('TWOP_B');     {'B - buscar contedos'}
    MenuAdiciona ('TWOP_M');     {'M - enviar mensagem direta'}
    MenuAdiciona ('TWOP_D');     {'D - mensagens diretas para mim'}
    MenuAdiciona ('TWOP_I');     {'I - obter informaes sobre algum'}
    MenuAdiciona ('TWOP_A');     {'A - amigos e seguidores'}
    MenuAdiciona ('TWOP_S');     {'S - seguidores'}
    MenuAdiciona ('TWOP_C');     {'C - configuraes'}
    MenuAdiciona ('TWOP_ESC');   {'ESC - terminar'}

    n := popupMenuSeleciona;
    if (n < 1) then
        result := ' '
    else
        result := opmenu[n];
end;

{--------------------------------------------------------}

procedure processa;
var c, c2: char;
    acabou: boolean;
begin
    clrscr;
    titulo;
    sintSom('TWAPF1');  {'Use as setas ou aperte F1 para ajuda'}

    acabou := false;
    repeat
        gotoxy (38, 25);
        clreol;
        gotoxy (40, 25);
        write (pegaTextoMensagem('TWAPF1'));  {'Use as setas ou perte F1 para ajuda'}
        titulo;

        sintBip;
        textBackground (BLUE);
        mensagem ('TWOPCAO', 0);   {'Twit: '}
        textBackground (BLACK);
        clreol;
        sintLeTecla (c, c2);
        writeln;
        limpaBaixo;

        if c = #$0 then
            case c2 of
            F1, F9:  begin
                        ajudaPrincipal;
                        c := ' ';
                     end;
                CIMA, BAIX: c := selSetasOpcao;
            end;

        if c = ' ' then
            continue;
        if c in ['a'..'z'] then
            c := upcase(c);

        case c of
            ESC:   begin
                       mensagem ('TWCNFFIM', 0);   {'Confirma fim? '}
                       sintLeTecla (c, c2);
                       writeln;
                       if upcase (c) = 'S' then
                           acabou := true;
                    end;

            'T': postar;
            'L': folhearTwits;
            'B': buscarConteudos;
            'F': folheamento;
            'M': enviarMsgDireta('');
            'D': folhearDiretas;
            'I': informacoesUsuario;
            'A': amigos;
            'S': seguidores;
            'C': configuracoes;

        else
            mensagem ('TWOPINV', 1);   {'Opo invlida, F1 ajuda.'}
        end;
    until acabou;
    writeln;
end;

{--------------------------------------------------------}

begin
    inicializa;
    configServidor;
    if configUsuario then
        begin
            mensagem ('TWOK', 1);   {'OK'}
            setWindowTitle ('Twitvox ' + username);
            processa;
        end;
    finaliza;
end.

