{--------------------------------------------------------}
{                                                        }
{    Programa de acesso a redes sociais                  }
{                                                        }
{    Mdulo de informaes sobre um usurio              }
{                                                        }
{    Autor: Jos Antonio Borges                          }
{                                                        }
{    Em dezembro/2011                                    }
{                                                        }
{--------------------------------------------------------}

unit twlogin;

interface
uses windows, sysutils, dvcrt, dvwin, dvForm, dvmacro,
     twvars, twoauth, twapi, twmsg, shellapi, classes, dvexec;

procedure configServidor;
function configUsuario: boolean;

implementation

function miniCodec (senha: string): string;
var i: integer;
const chcod: string = '30944123412563423441234587265986123486982346981237466';
begin
    for i := 1 to length(senha) do
        senha[i] := chr(ord(senha[i]) xor (ord(chcod[i]) and $f));
    result := senha;
end;

{--------------------------------------------------------}

procedure configServidor;
label desistiu;
begin
    setOauthConsumer(sintAmbiente ('TWITVOX', 'CONSUMER_KEY'),
                     sintAmbiente ('TWITVOX', 'CONSUMER_SECRET'),
                     sintAmbiente ('TWITVOX', 'SITE'),
                     sintAmbiente ('TWITVOX', 'REFURL'));
end;

{--------------------------------------------------------}

function testaChaves (temp_oauth_token, temp_oauth_secret: string): boolean;
var salva_token, salva_secret: string;
    status: integer;
begin
    salva_token := oauth_token;
    salva_secret := oauth_secret;
    oauth_token := temp_oauth_token;
    oauth_secret := temp_oauth_secret;

    getOauthTwitterRest ('/1.1/account/verify_credentials.json', status);
    result := status = 200;

    oauth_token := salva_token;
    oauth_secret := salva_secret;
end;

{--------------------------------------------------------}

function autentica (username, password: string;
                    var new_oauth_token, new_oauth_secret: string): boolean;
var c, c2: char;
    chaveOk: boolean;
    temp_access_token, temp_access_secret: string;
    pin: string;
label desistiu;

    function configManual: boolean;
    begin
        result := false;

        mensagem ('TWABRNAV', 1); {'Vou abrir um navegador para completar sua autorizao.}
        mensagem ('TWCPFORM', 1); {'Digite sua conta, aperte TAB, digite sua senha e ao final tecle Enter.'}
        mensagem ('TWESCPIN', 2); {'Finalmente, copie e transcreva no Twitvox o nmero que aparecer na tela.'}
        while sintFalando do delay (1000);

        getOAuthToken ('request_token', '', '', '',
                       temp_access_token, temp_access_secret);

        browseOAuthAuthenticate (temp_access_token, username);

        delay (5000);
        while getForegroundWindow <> crtWindow do delay (500);

        write (pegaTextoMensagem('TWNUMCOP'));   {'Nmero copiado: '}
        if sintEditaCampo (pin, wherex, wherey, 20, 20, true) = ESC then
            exit;

        writeln;
        result := getOAuthToken ('access_token',
                                 temp_access_token, temp_access_secret, pin,
                                 new_oauth_token, new_oauth_secret);
    end;


    function configAuto: boolean;
    var data: array [0..1000] of char;
        i: integer;
        s: string;
    begin
        result := false;

        mensagem ('TWDIGUSR', 0);  {'Informe seu conta previamente criada no Twitter: '}
        sintReadln (username);
        username := trim (username);
        if username = '' then exit;
        if username[1] = '@' then delete (username, 1, 1);
        if username = '' then exit;

        mensagem ('TWDIGPSW' , 0); {'Informe sua senha previamente criada no Twitter: '}
        textBackground (WHITE);
        readln (password);
        textBackground (BLACK);
        if password = '' then exit;

        mensagem ('TWABRNAV', 1); {'Vou abrir um navegador para completar sua autorizao.}
        while sintFalando do delay (1000);

        getOAuthToken ('request_token', '', '', '',
                       temp_access_token, temp_access_secret);

        executaProg(GetDefaultBrowser, '',
                'https://' + oauth_site + '/oauth/authenticate' +
                '?force_login=true&screen_name=' + username +
                '&oauth_token=' + temp_access_token);

        mensagem ('TWNAODIG', 1); {'Por favor no toque no teclado nem mova o mouse at que eu avise.'}

        for i := 1 to 10 do
            begin
                delay (1000);
                sintClek;
            end;

        mensagem ('TWEUDIG',  1); {'Vou digitar os dados para voc.'}
        while sintFalando do delay (1000);

        limpaBufTec;
        keyboardString(password, 100);
        keyboardVirtKey(VK_TAB, false, false, false, 200);
        keyboardVirtKey(VK_TAB, false, false, false, 200);
        keyboardVirtKey(VK_TAB, false, false, false, 200);
        keyboardVirtKey(VK_RETURN, false, false, false, 200);
        delay (5000);
        keyboardVirtKey(ord('A'), true, false, false, 500);
        keyboardVirtKey(ord('C'), true, false, false, 500);
        getClipBoard(data, 1000);
        pin := strPas(data);
        delete (pin, 1, pos('PIN', pin));
        delete (pin, 1, pos(':', pin));

        s := '';
        for i := 1 to length(pin) do
            begin
                if pin[i] in ['0'..'9'] then s := s + pin[i];
                if length(s) = 7 then break;
            end;
        pin := s;

        keyboardVirtKey (VK_F4, false, false, true, 1000);

        showWindow (crtWindow, SW_SHOWMINIMIZED);
        showWindow (crtWindow, SW_SHOWNORMAL);

        if (pin = '') or
           (not (pin[1] in ['0'..'9'])) or
           (not (pin[7] in ['0'..'9'])) then
               begin
                   mensagem ('TWERRO', 1);   {'Erro no processamento'}
                   exit;
               end;

        mensagem ('TWNUMCOP', 1);   {'Nmero copiado: '}
        writeln (pin);
        sintSoletra (pin);

        writeln;
        result := getOAuthToken ('access_token',
                                 temp_access_token, temp_access_secret, pin,
                                 new_oauth_token, new_oauth_secret);
    end;

begin
    result := false;

    writeln;
    mensagem ('TWAUTO', 0);    {'Posso realizar sua autorizao automaticamente? '}
    sintLeTecla (c, c2);
    writeln;
    if c = #$1b then exit;

    if upcase(c) = 'N' then
        begin
            if not configManual then goto desistiu;
        end
    else
        begin
            if not configAuto then goto desistiu;
        end;

    mensagem ('TWAUTOK', 1);   {'Autorizao concedida!'}

    chaveOk := testaChaves (new_oauth_token, new_oauth_secret);
    if not chaveOK then
        mensagem ('TWERRCHV', 1);   {'As chaves de acesso no conferem.'}

    result := chaveOk;
    exit;

desistiu:
    mensagem ('TWDESIST', 1);   {'Desistiu...'}
    result := false;
end;

{--------------------------------------------------------}

function folheiaUsuarioLista: string;
var sl: TStringList;
    itens: array[0..8000] of char;
    p: pchar;
    i, n: integer;
begin
    result := '';
    getPrivateProfileString (nil, nil, '', itens, 8000, pChar(twitvoxConfigs));

    p := @itens;
    sl := TStringList.Create;
    while p^ <> #$0 do
        begin
            sl.Add(strPas(p));
            p := p + strlen(p) + 1;
        end;
    if sl.count = 0 then
        begin
            mensagem ('TWSEMREG', 1);    {'No h usurios registrados'}
            exit;
        end;

    popupMenuCria(wherex, wherey, 30, sl.count, RED);
    for i := 0 to sl.count-1 do
        popupMenuAdiciona('', sl[i]);
    popupMenuOrdena;
    n := popupMenuSeleciona;

    if n < 0 then
        begin
            mensagem ('TWDESIST', 1);
            exit;
        end;

    result := opcoesItemSelecionado;
end;

{--------------------------------------------------------}

function pegaUsuarioLista (username: string;
                            var password, access_key, access_secret: string): boolean;
begin
    password      := sintAmbienteArq (username, 'PASSWORD',      '', twitvoxConfigs);
    access_key    := sintAmbienteArq (username, 'ACCESS_KEY',    '', twitvoxConfigs);
    access_secret := sintAmbienteArq (username, 'ACCESS_SECRET', '', twitvoxConfigs);
    result := access_key <> '';
end;

{--------------------------------------------------------}

procedure guardaUsuarioLista (username, password, access_key, access_secret: string);
begin
    sintGravaAmbienteArq (username, 'PASSWORD',      password,      twitvoxConfigs);
    sintGravaAmbienteArq (username, 'ACCESS_KEY',    access_key,    twitvoxConfigs);
    sintGravaAmbienteArq (username, 'ACCESS_SECRET', access_secret, twitvoxConfigs);
end;

{--------------------------------------------------------}

function configUsuario: boolean;
var c, c2: char;
    escolhe: boolean;
    new_user, new_password, new_oauth_token, new_oauth_secret: string;

label deNovo, registra, desistiu;

begin
    result := true;

    username := sintAmbiente ('TWITVOX', 'USERNAME');
    password := sintAmbiente ('TWITVOX', 'PASSWORD');
    if username = '' then
        username := 'fulano_dv';

    oauth_token := sintAmbiente ('TWITVOX', 'ACCESS_KEY');
    oauth_secret := sintAmbiente ('TWITVOX', 'ACCESS_SECRET');

    escolhe := true;
    if username <> '' then
        begin
            limpaBufTec;
            mensagem ('TWUSUATU', 0);  {'Usurio atual: '}
            sintWriteln (username);

            guardaUsuarioLista (username, password, oauth_token, oauth_secret);

            mensagem ('TWCNFCON', 0);   {'Confirma usurio e senha atuais? '}
            sintLeTecla (c, c2);
            if c = #$1b then goto desistiu;

            if c > #$20 then writeln;
            escolhe := upcase(c) = 'N';
        end;

    writeln;
    if escolhe then
        begin
deNovo:
            new_user := username;
            mensagem ('TWUSUSET', 0);   {'Informe o usurio ou use as setas: '}
            c := sintEdita(new_user, wherex, wherey, 80, true);
            writeln;
            new_user := trim(new_user);
            if (c = #$1b) or (new_user = '') then goto desistiu;

            if (c = BAIX) or (c = CIMA) then
                begin
                    new_user := folheiaUsuarioLista;
                    writeln (new_user);
                    if new_user = '' then goto desistiu;
                    if not pegaUsuarioLista (new_User, new_password, new_oauth_token, new_oauth_secret) then
                        goto deNovo;
                end;

            pegaUsuarioLista (new_user, new_password, new_oauth_token, new_oauth_secret);

            if testaChaves (new_oauth_token, new_oauth_secret) then
                goto registra;

            mensagem ('TWERRCHV', 1);   {'As chaves de acesso no conferem.'}
            writeln;
            textBackground (BLUE);
            mensagem ('TWCNFCOD', 1);   {'Configurando os cdigos de acesso.'}
            textBackground (BLACK);

            if not autentica (new_user, new_password, new_oauth_token, new_oauth_secret) then
                goto desistiu;

registra:
            username := new_user;
            password := new_password;
            oauth_token := new_oauth_token;
            oauth_secret := new_oauth_secret;

            sintGravaAmbiente ('TWITVOX', 'USERNAME',      username);
            sintGravaAmbiente ('TWITVOX', 'ACCESS_KEY',    oauth_token);
            sintGravaAmbiente ('TWITVOX', 'ACCESS_SECRET', oauth_secret);

            guardaUsuarioLista(username, password, oauth_token, oauth_secret);

            mensagem ('TWOK', 1);  {'OK'}
        end;

exit;

    desistiu:
    mensagem ('TWDESIST', 1);   {'Desistiu...'}
    result := false;
end;

end.

