{--------------------------------------------------------}
{                                                        }
{    Programa de acesso a redes sociais                  }
{                                                        }
{    Mdulo de postagem                                  }
{                                                        }
{    Autor: Jos Antonio Borges                          }
{                                                        }
{    Em janeiro/2011                                     }
{                                                        }
{--------------------------------------------------------}

unit twpost;

interface
uses sysutils, dvcrt, dvwin, twvars, twmsg, twOauth, twapi, twutil, twjson;

procedure postar;
procedure enviarMsgDireta (quem: string);
procedure replicar (pst: PStatus);
procedure replicarmsgDireta (sender: PDirectMessage);
procedure retuitar (pst: PStatus);
procedure destruir (id: string);

implementation

function pedeTexto (inicial: string): string;
var txt: string;
    c: char;
begin
    txt := inicial;
    mensagem ('TWDIGTXT', 1);    {'Digite o texto a enviar'}
    c := sintEdita (txt, wherex, wherey, 140, true);
    if c = ESC then
        txt := ''
    else
        writeln (txt);

    if txt = '' then
        begin
            mensagem ('TWDESIST', 1);   {'Desistiu...'}
            exit;
        end;
    result := ansiToUtf8(txt);
end;

{--------------------------------------------------------}

procedure postar;
var
    txt: string;
begin
    txt := pedeTexto('');

    if username = 'fulano_dv' then
        begin
            mensagem ('TWUSTEST', 1);   {'Este usurio  s para testes, no manda mensagens.'}
            exit;
        end;

    if txt <> '' then
        postToTwitter ('/1.1/statuses/update.json',
                       'status='+urlEncode2(txt));
end;

{--------------------------------------------------------}

procedure replicar (pst: PStatus);
var
    txt: string;
    idmsg, quem: string;
begin
    mensagem ('TWNAOELN', 0);   {'Ao teclar em seguida, no elimine o nome pr-digitado'}
    idmsg := pst^.id;
    quem := pst^.user^.screen_name;
    sintWriteln (' @' + quem);
    limpaBufTec;
    txt := pedeTexto('@' + quem + ' ');

    if username = 'fulano_dv' then
        begin
            mensagem ('TWUSTEST', 1);   {'Este usurio  s para testes, no manda mensagens.'}
            exit;
        end;

    if txt <> '' then
        postToTwitter ('/1.1/statuses/update.json',
                       'status='+urlEncode2(txt));
end;

{--------------------------------------------------------}

procedure enviarMsgDireta (quem: string);
var
    apelido: string;
    txt: string;
begin
    if quem <> '' then
        apelido := quem
    else
        begin
            mensagem ('TWAPEDST', 0);     {'Informe o apelido do destinatrio: '}
            sintReadln (apelido);
            if apelido = '' then
                begin
                    mensagem ('TWDESIST', 1);   {'Desistiu...'}
                    exit;
                end;
        end;
    if apelido[1] = '@' then delete (apelido, 1, 1);

    txt := pedeTexto ('');

    if username = 'fulano_dv' then
        begin
            mensagem ('TWUSTEST', 1);   {'Este usurio  s para testes, no manda mensagens.'}
            exit;
        end;

    if txt <> '' then
(*        postToTwitter ('/1.1/direct_messages/new.json',
                       'screen_name='+urlEncode2(apelido) +
                       '&text='+urlEncode2(txt));
*)
        postToTwitter ('/1.1/direct_messages/events/new.json',
                       '{"event": {"type": "message_create", '+
                       '"message_create": {"target": {"recipient_id": '
                                            + urlEncode2(apelido) + '}, '+
                       '"message_data": {"text": "'
                                            + urlEncode2(txt) + '"}}}}');
end;

(*
twurl <https://github.com/twitter/twurl>`_ -A
'Content-type: application/json' -X
POST
/1.1/direct_messages/events/new.json
-d
'{"event": {"type": "message_create",
"message_create": {"target": {"recipient_id": "RECIPIENT_USER_ID"},
"message_data": {"text": "Hello World!"}}}}'



header 'authorization: OAuth oauth_consumer_key="YOUR_CONSUMER_KEY",
       oauth_nonce="AUTO_GENERATED_NONCE",
       oauth_signature="AUTO_GENERATED_SIGNATURE",
       oauth_signature_method="HMAC-SHA1",
       oauth_timestamp="AUTO_GENERATED_TIMESTAMP",
       oauth_token="USERS_ACCESS_TOKEN",
       oauth_version="1.0"'

--header 'content-type: application/json'
*)

{--------------------------------------------------------}

procedure replicarMsgDireta (sender: PDirectMessage);
var txt: string;
    apelido: string;
begin
    apelido := sender^.sender_screen_name;
    mensagem ('TWRESNDN', 0);    {'Respondendo a '}
    sintWriteln (apelido);
    txt := pedeTexto('');

    if username = 'fulano_dv' then
        begin
            mensagem ('TWUSTEST', 1);   {'Este usurio  s para testes, no manda mensagens.'}
            exit;
        end;

    if txt <> '' then
        postToTwitter ('/1.1/direct_messages/new.json',
                       'screen_name='+urlEncode2(apelido) +
                       '&text='+urlEncode2(txt));
end;

{--------------------------------------------------------}

procedure retuitar (pst: PStatus);
begin
    mensagem ('TWRETWIT', 1);    {'Retuitando...'}

    if username = 'fulano_dv' then
        begin
            mensagem ('TWUSTEST', 1);   {'Este usurio  s para testes, no manda mensagens.'}
            exit;
        end;

    postToTwitter ('/1.1/statuses/retweet/' + pst^.id+ '.json', '');

//    mensagem ('TWEDITXT', 1);    {'Editore o texto a enviar, enter envia igual'}
//    txt := pst^.text;
//    original := txt;
//    c := sintEdita (txt, wherex, wherey, 140, true);
//    if c = ESC then
//        begin
//            mensagem ('TWDESIST', 1);  {'Desistiu'}
//            exit;
//        end;

//    writeln (txt);
//    if txt = original then
//        postToTwitter ('/1.1/statuses/retweet/' + pst^.id+ '.json', '')
//    else
//        postToTwitter ('/1.1/statuses/update.json',
//                       'in_reply_to_status_id=' + pst^.id +
//                       '&status='+urlEncode2(ansiToUtf8(txt)));
end;

{--------------------------------------------------------}

procedure destruir (id: string);
var c, c2: char;
    resp: string;
begin
    mensagem ('TWQUERDS', 0);    {'Quer mesmo destruir esta mensagem? '}
    sintLeTecla (c, c2);
    writeln;
    if upcase(c) <> 'S' then
        begin
            mensagem ('TWDESIST', 1);   {'Desistiu...'}
            exit;
        end;

    if username = 'fulano_dv' then
        begin
            mensagem ('TWUSTEST', 1);   {'Este usurio  s para testes, no manda mensagens.'}
            exit;
        end;

    requestToTwitter ('/1.1/statuses/destroy/' + id+ '.json', '', resp);
end;

end.

